Option Explicit

#include ..\lib\framework_domotics.vbs
#include local-parameters.inc

'----------------------------------------------------------------------------------------------
'-- USE CASES:
'-- 1/ 90,100,110,120,130 (Normal)
'-- 2/ 90,100,0,110,120 (Ano -)
'-- 3/ 90,100,0,10,20 (Cut)
'-- 4/ 0,5,7,10,100 (Normal)
'-- 5/ 90,100,1000,110,120 (Ano +)

'----------------------------------------------------------------------------------------------
'-- JEU DE TESTS (Chez moi uniquement :->)
'-- 2007-12-25            => Normal Day => 0 cuts, Night=2824,  Day= 3875
'-- 2007-12-06 13:26:27   => Ano + => Day=2337, Night=2010
'-- 2007-11-17 01:24:50   => Ano + => Day 2661, Night=2125
'-- 2007-12-17            => Cas particulier => Une conso  00:00:00
'-- 2007-11-03            => Cut  => 1 cut, Night = 1749, Day=2986  
'-- 2007-10-16 18:40:40   => Ano - => Night=705, Day=1225
'-- 2007-10-28            => Ano + => 66 Anos, Night=1108, Day=1780 

'----------------------------------------------------------------------------------------------
'-- LOADING PROPERTIES :
Dim astrSensor
Dim astrFileCuts
Dim astrFileAno
Dim astrFileSQL
Dim astrFileLogs
Dim astrSQL
Dim astrNight
Dim aintLimitMin
Dim aintLimitMax
Dim adblPriceNight
Dim adblPriceDay
Dim astrFormatCut
Dim astrFormatAno
Dim astrFormatElect
Dim astrFormatMoney
Dim astrDevTCuts
Dim astrDevTAno
Dim astrDevDayTConso
Dim astrDevNightTConso
Dim astrDevDayHour
Dim astrDevNightHour
Dim astrDevDayDay
Dim astrDevNightDay
Dim astrDevDayWeek
Dim astrDevNightWeek
Dim astrDevDayMonth
Dim astrDevNightMonth
Dim astrDevDayYear
Dim astrDevNightYear
Dim astrAllDev 
Dim aobjConn

astrSensor            = hs.GetINISetting("COMMON","SENSOR","[73", G_FILE_INI)
astrFileCuts          = hs.GetINISetting("COMMON","FILE_TCUTS","", G_FILE_INI)
astrFileAno           = hs.GetINISetting("COMMON","FILE_ANO","", G_FILE_INI)
astrFileSQL           = hs.GetINISetting("COMMON","FILE_SQL","", G_FILE_INI)
astrFileLogs          = hs.GetINISetting("COMMON","FILE_LOGS","", G_FILE_INI)
astrSQL               = hs.GetINISetting("COMMON","SQL","", G_FILE_INI)
astrNight             = hs.GetINISetting("COMMON","NIGHT","", G_FILE_INI)
aintLimitMin          = hs.GetINISetting("COMMON","LIMIT_MIN","", G_FILE_INI)
aintLimitMax          = hs.GetINISetting("COMMON","LIMIT_MAX","", G_FILE_INI)
adblPriceNight        = hs.GetINISetting("COMMON","PRICE_NIGHT","", G_FILE_INI)
adblPriceDay          = hs.GetINISetting("COMMON","PRICE_DAY","", G_FILE_INI)
astrFormatCut         = hs.GetINISetting("COMMON","FORMAT_CUT","", G_FILE_INI)
astrFormatAno         = hs.GetINISetting("COMMON","FORMAT_ANO","", G_FILE_INI)
astrFormatElect       = hs.GetINISetting("COMMON","FORMAT_ELECT","", G_FILE_INI)
astrFormatMoney       = hs.GetINISetting("COMMON","FORMAT_MONEY","", G_FILE_INI)
astrDevTCuts          = hs.GetINISetting("COMMON","DEV_TCUTS","", G_FILE_INI)
astrDevTAno           = hs.GetINISetting("COMMON","DEV_TANO","", G_FILE_INI)
astrDevDayTConso      = hs.GetINISetting("COMMON","DEV_DAY_TCONSO","", G_FILE_INI)
astrDevNightTConso    = hs.GetINISetting("COMMON","DEV_NIGHT_TCONSO","", G_FILE_INI)
astrDevDayHour        = hs.GetINISetting("COMMON","DEV_DAY_HOUR","", G_FILE_INI)
astrDevNightHour      = hs.GetINISetting("COMMON","DEV_NIGHT_HOUR","", G_FILE_INI)
astrDevDayDay         = hs.GetINISetting("COMMON","DEV_DAY_DAY","", G_FILE_INI)
astrDevNightDay       = hs.GetINISetting("COMMON","DEV_NIGHT_DAY","", G_FILE_INI)
astrDevDayWeek        = hs.GetINISetting("COMMON","DEV_DAY_WEEK","", G_FILE_INI)
astrDevNightWeek      = hs.GetINISetting("COMMON","DEV_NIGHT_WEEK","", G_FILE_INI)
astrDevDayMonth       = hs.GetINISetting("COMMON","DEV_DAY_MONTH","", G_FILE_INI)
astrDevNightMonth     = hs.GetINISetting("COMMON","DEV_NIGHT_MONTH","", G_FILE_INI)
astrDevDayYear        = hs.GetINISetting("COMMON","DEV_DAY_YEAR","", G_FILE_INI)
astrDevNightYear      = hs.GetINISetting("COMMON","DEV_NIGHT_YEAR","", G_FILE_INI)

astrAllDev            = "'" & astrDevTCuts & "',"
astrAllDev            = astrAllDev & "'" & astrDevTAno            & "',"
astrAllDev            = astrAllDev & "'" & astrDevDayTConso       & "',"
astrAllDev            = astrAllDev & "'" & astrDevNightTConso     & "',"
astrAllDev            = astrAllDev & "'" & astrDevDayHour         & "',"
astrAllDev            = astrAllDev & "'" & astrDevNightHour       & "',"
astrAllDev            = astrAllDev & "'" & astrDevDayDay          & "',"
astrAllDev            = astrAllDev & "'" & astrDevNightDay        & "',"
astrAllDev            = astrAllDev & "'" & astrDevDayWeek         & "',"
astrAllDev            = astrAllDev & "'" & astrDevNightWeek       & "',"
astrAllDev            = astrAllDev & "'" & astrDevDayMonth        & "',"
astrAllDev            = astrAllDev & "'" & astrDevNightMonth      & "',"
astrAllDev            = astrAllDev & "'" & astrDevDayYear         & "',"
astrAllDev            = astrAllDev & "'" & astrDevNightYear       & "'"

'--------------------------------------------------------------------
'-- OBJECTIVE   : MAIN PROGRAMME
'-- PREREQUISITE: RFXPOWER and RFXCOM
'-- PARAMS IN   : N/A
'-- PARAMS OUT  : N/A
'-- CREATED BY DOMOTICS
'-- 29/03/2007
'--------------------------------------------------------------------
Sub main()
Set aobjConn = CreateObject("ADODB.Connection")
aobjConn.Open(G_CONNECTION_STRING)
refreshConsumption "","",False                  '-- Refresh Current Day consumption (every hour)
aobjConn.Close
Set aobjConn  = Nothing
End sub

Sub refreshYesterday()
Dim adateCURR : adateCURR = DateAdd("D",-1,now)
Dim astrCURR  : astrCURR  = formatDay(adateCURR) 
Set aobjConn = CreateObject("ADODB.Connection")
aobjConn.Open(G_CONNECTION_STRING)
refreshConsumption  astrCURR, astrCURR , False 
aobjConn.Close
Set aobjConn  = Nothing
End sub

Sub RefreshLegacy()
Set aobjConn = CreateObject("ADODB.Connection")
aobjConn.Open(G_CONNECTION_STRING)
'refreshConsumption "2007-04-11", "2007-05-01", True        '-- Debut de mon RFXPOWER : 2007-04-11
'refreshConsumption "2007-05-02", "2007-06-01", False      
'refreshConsumption "2007-06-02", "2007-07-01", False
'refreshConsumption "2007-07-02", "2007-08-01", False
'refreshConsumption "2007-08-02", "2007-09-01", False
'refreshConsumption "2007-09-02", "2007-10-01", False
'refreshConsumption "2007-10-02", "2007-11-01", False
'refreshConsumption "2007-11-02", "2007-12-01", False
'refreshConsumption "2007-12-02", "2008-01-04", False
aobjConn.Close
Set aobjConn  = Nothing
End sub

'--------------------------------------------------------------------
'-- OBJECTIVE   : Calculate consumption for one day
'-- PREREQUISITE: RFXPOWER and RFXCOM
'-- PARAMS IN   : Day => Used to calculate the consumption
'--               Initial Total Consumption for "Day" period
'--               Initial Consumption for "Night" period
'--               Initial cuts 
'--               Initial anomalies
'--               Initial list of Cuts
'--               Initial list of Anomalies
'-- PARAMS OUT  : Total Consumption for "Day" period
'--               Total Consumption for "Night" period
'--               Total cuts 
'--               Total anomalies
'--               Final list of Cuts
'--               Final list of Anomalies
'-- CREATED BY DOMOTICS
'-- 29/12/2007
'--------------------------------------------------------------------
Sub parseValues(byval paramMode, byval paramDate, byref paramDayConso, byref paramNightConso, byref paramTotalCuts, byref paramCutsBuffer, byref paramTotalAno, byref paramAnoBuffer)
Dim aG_SCRIPT_EVT         : aG_SCRIPT_EVT         = "parseValues"
Dim adblDayConsumption    : adblDayConsumption    = 0
Dim adblNightConsumption  : adblNightConsumption  = 0
Dim adblLastValue         : adblLastValue         = -1
Dim adblCurrentValue      : adblCurrentValue      = -1
Dim astrGeneratedSQL      : astrGeneratedSQL      = ""
Dim aobjRS
Dim i 
Dim adateTmp
Dim aboolReturn
Dim astrTypeValue
Dim astrValue
Dim aboolCut
Dim adateLastAno

If (astrSQL <> "") Then
    astrGeneratedSQL        = replace(astrSQL,"##SENSOR##",astrSensor)
    astrGeneratedSQL        = replace(astrGeneratedSQL,"##DATE##",paramDate)
    adateTmp                = DateAdd("D",+1,paramDate)
    astrGeneratedSQL        = replace(astrGeneratedSQL,"##DATE+1##",formatDay(adateTmp))
    adateTmp                = DateAdd("D",-1,paramDate)
    astrGeneratedSQL        = replace(astrGeneratedSQL,"##DATE-1##",formatDay(adateTmp))
Else
    WriteLog G_FOLDER_NAME, aG_SCRIPT_EVT, G_TIV_SEV, "SQL Query empty !", G_LOG_FILE
End if          

WriteLog G_FOLDER_NAME, aG_SCRIPT_EVT, G_TIV_INF, "Launching the refresh ...", G_LOG_FILE
Set aobjRS     = aobjConn.Execute(astrGeneratedSQL)
SaveFileAppend astrFileSQL, astrGeneratedSQL
If NOT(aobjRS.EOF) Then
    adblLastValue = aobjRS.Fields.Item(0)
    aobjRS.MoveNext  
    i             = 0
    aboolCut      = False
    While NOT(aobjRS.EOF)
        adblCurrentValue  = aobjRS.Fields.Item(0)
        saveDetailedLogs astrFileLogs,"[ LimitMax=" & aintLimitMax , paramMode
        saveDetailedLogs astrFileLogs,"  Conso Actuelle : Day=" & adblDayConsumption & ", Night=" & adblNightConsumption , paramMode
        saveDetailedLogs astrFileLogs,"  Last Conso.=" & adblLastValue & ", Curr. Conso.=" & adblCurrentValue & ", Date Curr. Conso.=" & aobjRS.Fields.Item(1)  , paramMode        
        If CDbl(adblLastValue) <= CDbl(adblCurrentValue) Then
            If CDbl(abs(adblCurrentValue - adblLastValue)) < CDbl(aintLimitMax) Then
                aboolReturn = True
                doExpression replace(astrNight,"##CURR##",split(aobjRS.Fields.Item(1)," ")(1)), aboolReturn, astrTypeValue, astrValue
                If aboolReturn Then
                    If (astrTypeValue = G_STATUS_ON) Then
                        adblNightConsumption = adblNightConsumption + adblCurrentValue - adblLastValue
                    Else '-- G_STATUS_OFF
                        adblDayConsumption  = adblDayConsumption + adblCurrentValue - adblLastValue
                    End if
                Else
                    WriteLog G_FOLDER_NAME, aG_SCRIPT_EVT, G_TIV_SEV, "doExpression returns false (" & aobjRS.Fields.Item(1) & ") !", G_LOG_FILE
                End if               
                adblLastValue = adblCurrentValue
                saveDetailedLogs astrFileLogs,"  UC1 (Normal) : CurrentValue - LastValue < aintLimitMax ~ " & CDbl(abs(adblCurrentValue - adblLastValue)) & " < " & CDbl(aintLimitMax) , paramMode
            Else
                paramTotalAno  = paramTotalAno + 1
                paramAnoBuffer = paramAnoBuffer & aobjRS.Fields.Item(1) & "<br/>"
                saveDetailedLogs astrFileLogs,"  UC2 (Ano + ) : CurrentValue - LastValue >= aintLimitMax ~ " & CDbl(abs(adblCurrentValue - adblLastValue)) & " >= " & CDbl(aintLimitMax) , paramMode                               
            End if
            If aboolCut Then
                saveDetailedLogs astrFileLogs,"  UC3 (Ano - ) : CurrentValue - LastValue >= aintLimitMax ~ " & CDbl(abs(adblCurrentValue - adblLastValue)) & " >= " & CDbl(aintLimitMax) , paramMode            
                paramTotalAno  = paramTotalAno + 1
                paramAnoBuffer = paramAnoBuffer & adateLastAno & "<br/>"
            End if
            aboolCut = False
        Else
            If aboolCut Then           
              If CDbl(adblCurrentValue) <= CDbl(aintLimitMin) Then
                  paramTotalCuts  =  paramTotalCuts + 1
                  paramCutsBuffer = paramCutsBuffer & aobjRS.Fields.Item(1) & "<br/>"
                  aboolReturn = True
                  doExpression replace(astrNight,"##CURR##",split(aobjRS.Fields.Item(1)," ")(1)), aboolReturn, astrTypeValue, astrValue
                  If aboolReturn Then
                      If (astrTypeValue = G_STATUS_ON) Then
                          adblNightConsumption = adblNightConsumption + adblCurrentValue 
                      Else '-- G_STATUS_OFF
                          adblDayConsumption  = adblDayConsumption + adblCurrentValue 
                      End if
                  Else
                      WriteLog G_FOLDER_NAME, aG_SCRIPT_EVT, G_TIV_SEV, "doExpression returns false (" & aobjRS.Fields.Item(1) & ") !", G_LOG_FILE
                  End if
                  adblLastValue = adblCurrentValue
                  saveDetailedLogs astrFileLogs,"  UC4 (Cut) : LastValue > CurrentValue and adblCurrentValue <= aintLimitMin ~ " & CDbl(adblLastValue) & " > " & CDbl(adblCurrentValue) & " and " & CDbl(adblCurrentValue) & " <= " & CDbl(aintLimitMin), paramMode
                  aboolCut = False                  
              Else
                  saveDetailedLogs astrFileLogs,"  UC5 (Ano - TBD) : LastValue > CurrentValue but adblCurrentValue > aintLimitMin ~ " & CDbl(adblLastValue) & " > " & CDbl(adblCurrentValue) & " but " & CDbl(adblCurrentValue) & " > " & CDbl(aintLimitMin), paramMode            
                  adateLastAno = aobjRS.Fields.Item(1)
                  aboolCut = True
              End if
            Else
              saveDetailedLogs astrFileLogs,"  UC6 (Ano - TBD) : LastValue > CurrentValue ~ " & CDbl(adblLastValue) & " > " & CDbl(adblCurrentValue) , paramMode            
              adateLastAno = aobjRS.Fields.Item(1)
              aboolCut = True
            End if
        End if
        saveDetailedLogs astrFileLogs,"  End Loop : Last Conso.=" & adblLastValue & ", Curr. Conso.=" & adblCurrentValue & ", Day=" & adblDayConsumption & ", Night=" & adblNightConsumption , paramMode
        saveDetailedLogs astrFileLogs,"] ", paramMode        
        aobjRS.MoveNext       
    Wend
Else
    WriteLog G_FOLDER_NAME, aG_SCRIPT_EVT, G_TIV_CRI, "No result for " & paramDate, G_LOG_FILE
End if
aobjRS.Close 
Set aobjRS    = Nothing

WriteLog G_FOLDER_NAME, aG_SCRIPT_EVT, G_TIV_INF, "Report: " & paramTotalCuts & " cut(s), " & paramTotalAno & " ano(s), Night=" & adblNightConsumption & " KWh, Day=" & adblDayConsumption & " Kwh", G_LOG_FILE

paramDayConso   = adblDayConsumption
paramNightConso = adblNightConsumption

WriteLog G_FOLDER_NAME, aG_SCRIPT_EVT, G_TIV_INF, "End of the refresh", G_LOG_FILE
End sub

'--------------------------------------------------------------------
'-- OBJECTIVE   : CALCULATE CONSUMPTION FOR a GIVEN PERIOD
'-- PREREQUISITE: RFXPOWER and RFXCOM
'-- PARAMS IN   : First Day and Last Day 
'--               ParamMode => True if we are recalculating all values
'-- PARAMS OUT  : N/A
'-- CREATED BY DOMOTICS
'-- 29/12/2007
'--------------------------------------------------------------------
Sub refreshConsumption(paramFirstDate, paramLastDate, paramMode)
Dim aG_SCRIPT_EVT : aG_SCRIPT_EVT = "refreshConsumption"
Dim adateCurr
Dim i
Dim astrI               : astrI                 = ""
Dim aintTotalCuts       : aintTotalCuts         = Cdbl(0)
Dim aintTotalAno        : aintTotalAno          = Cdbl(0)
Dim astrCutsBuffer      : astrCutsBuffer        = ""
Dim astrAnoBuffer       : astrAnoBuffer         = ""
Dim alngTotalDayConso   : alngTotalDayConso     = Cdbl(0)
Dim alngTotalNightConso : alngTotalNightConso   = Cdbl(0)
Dim alngDayConso        : alngDayConso          = Cdbl(0)
Dim alngNightConso      : alngNightConso        = Cdbl(0)
Dim astrGeneratedSQL    : astrGeneratedSQL      = ""
Dim astrRET             : astrRET               = ""
Dim aobjRS
Dim alngLastConso       
Dim adateDAYMOINS1
Dim aboolERR            : aboolERR              = False

WriteLog G_FOLDER_NAME, aG_SCRIPT_EVT, G_TIV_INF, "Launching the refresh ...", G_LOG_FILE
If CheckDevices(G_FOLDER_NAME, G_FILE_INI, G_STATUS_EXIST) Then
    adateCurr = now
    If paramFirstDate = "" Then
        paramFirstDate = formatDay(adateCurr)   
    End if
    If paramLastDate = "" Then
        paramLastDate = formatDay(adateCurr)  
    End if      
    If isDate(paramFirstDate) And isDate(paramLastDate) Then
        If DateDiff("D",paramFirstDate,paramLastDate) >= 0 Then
            If paramMode Then
                WriteLog G_FOLDER_NAME, aG_SCRIPT_EVT, G_TIV_INF, "Erasing previous calculated values ...", G_LOG_FILE            
                
'--     ERASING ALL PREVIOUS CALCULATED VALUES       
                SaveFileByType astrFileSQL, "List all SQL Queries for a refreshCunsumption call ...", G_FILETYPE_ASCII
                astrGeneratedSQL = "DELETE FROM events WHERE device in (" & astrAllDev & ")"
                SaveFileAppend astrFileSQL, astrGeneratedSQL
                astrRET = runSQLQuery( astrGeneratedSQL)
                If astrRET <> "" Then
                    WriteLog G_FOLDER_NAME, aG_SCRIPT_EVT, G_TIV_CRI, "Error on SQL execution : " & astrRET, G_LOG_FILE
                End if
                
'--     RESETING GLOBAL VALUES
                aintTotalCuts         = Cdbl(0)
                aintTotalAno          = Cdbl(0)
                alngTotalDayConso     = Cdbl(0)
                alngTotalNightConso   = Cdbl(0)
                
'--     ERASING ALL PREVIOUS CUTS AND ANOMALIES            
                deleteFile(astrFileCuts)
                deleteFile(astrFileAno)
                deleteFile(astrFileLogs)
                
            Else
                WriteLog G_FOLDER_NAME, aG_SCRIPT_EVT, G_TIV_INF, "Reloading previous calculated values ...", G_LOG_FILE
                
'--     RELOADING GLOBAL VALUES 
                adateDAYMOINS1        = DateAdd("D", -1, paramFirstDate)
                aintTotalCuts         = getLastValueFromDb(astrDevTCuts,       adateDAYMOINS1, 0) 
                aintTotalAno          = getLastValueFromDb(astrDevTAno,        adateDAYMOINS1, 0)
                alngTotalDayConso     = getLastValueFromDb(astrDevDayTConso,   adateDAYMOINS1, 0) 
                alngTotalNightConso   = getLastValueFromDb(astrDevNightTConso, adateDAYMOINS1, 0)               
              
                If (alngTotalDayConso = 0) or (alngTotalNightConso = 0) Then
                    WriteLog G_FOLDER_NAME, aG_SCRIPT_EVT, G_TIV_SEV, "Last Cuts.Ano.Consumption unfound on " & formatDay(adateDAYMOINS1), G_LOG_FILE
                    aboolERR = True
                End if
                                   
'--     RELOADING PREVIOUS ANO AND CUTS    
                If isFileExist(astrFileCuts) Then
                    astrCutsBuffer  = LoadFile(astrFileCuts, False)
                Else
                    astrCutsBuffer = ""
                End if  
                If isFileExist(astrFileAno) Then
                    astrAnoBuffer   = LoadFile(astrFileAno, False)
                Else
                    astrAnoBuffer = ""
                End if
            End if                  
                       
'--     CALCULATING VALUES FOR GIVEN DAYS        
            i = paramFirstDate
            While (DateDiff("D",i,paramLastDate) >= 0) and NOT(aboolERR)
                astrI = formatDay(i)  
                WriteLog G_FOLDER_NAME, aG_SCRIPT_EVT, G_TIV_INF, "Proceeding " & astrI & " ... ", G_LOG_FILE
                parseValues paramMode, astrI, alngDayConso, alngNightConso, aintTotalCuts, astrCutsBuffer, aintTotalAno, astrAnoBuffer
                            
                alngTotalDayConso   = CDBL(alngTotalDayConso + alngDayConso)
                alngTotalNightConso = CDBL(alngTotalNightConso + alngNightConso)
               
                setConsumption astrDevDayWeek,   getConsoForNDays(astrDevDayDay,7,i)      + alngDayConso,    "DAY", i
                setConsumption astrDevNightWeek, getConsoForNDays(astrDevNightDay,7,i)    + alngNightConso,  "NIGHT", i
                setConsumption astrDevDayMonth,  getConsoForNDays(astrDevDayDay,30,i)     + alngDayConso,    "DAY", i               
                setConsumption astrDevNightMonth,getConsoForNDays(astrDevNightDay,30,i)   + alngNightConso,  "NIGHT", i
                setConsumption astrDevDayYear,   getConsoForNDays(astrDevDayDay,365,i)    + alngDayConso,    "DAY", i               
                setConsumption astrDevNightYear, getConsoForNDays(astrDevNightDay,365,i)  + alngNightConso,  "NIGHT", i
                
                setConsumption astrDevDayDay, alngDayConso, "DAY", i
                setConsumption astrDevNightDay, alngNightConso, "NIGHT", i
                
                setConsumption astrDevDayTConso, alngTotalDayConso, "DAY", i
                setConsumption astrDevNightTConso, alngTotalNightConso, "NIGHT", i
                  
                setCutsOrAnos astrDevTCuts, aintTotalCuts, astrFormatCut, astrFileCuts,astrCutsBuffer, i
                setCutsOrAnos astrDevTAno, aintTotalAno, astrFormatAno, astrFileAno, astrAnoBuffer, i
                                                           
                i = DateAdd("D", +1, i)
            Wend
        
            setDevice astrDevDayHour, G_DEFAULT_VALUE, "", ""
            setDevice astrDevNightHour, G_DEFAULT_VALUE, "", "" 
                              
        Else
            WriteLog G_FOLDER_NAME, aG_SCRIPT_EVT, G_TIV_SEV, "Last date is greater than first date !", G_LOG_FILE
        End if
    Else
        WriteLog G_FOLDER_NAME, aG_SCRIPT_EVT, G_TIV_SEV, "One parameter is not a date", G_LOG_FILE
    End if
Else
    WriteLog G_FOLDER_NAME, aG_SCRIPT_EVT, G_TIV_SEV, "Expected Device is unknown !", G_LOG_FILE	
End if
WriteLog G_FOLDER_NAME, aG_SCRIPT_EVT, G_TIV_INF, "End of the refresh", G_LOG_FILE
End Sub

'--------------------------------------------------------------------
'-- OBJECTIVE   : Set And Save Consumption 
'--               No Save for the current Day 
'-- PREREQUISITE: RFXPOWER and RFXCOM
'-- PARAMS IN   : paramDevice => Device used to assign the consumption
'--               paramConso  => Consumption to be assigned
'--               paramPrice  => Unitary Price to be used
'--               paramDay    => Day related to the consumption
'-- PARAMS OUT  : N/A
'-- CREATED BY DOMOTICS
'-- 29/12/2007
'--------------------------------------------------------------------
Sub setConsumption(paramDevice,paramConso,paramPrice,paramDay)
Dim astrBuffer
Dim adateCURR   : adateCURR = now
Dim adateCONSO  
Dim astrSQL
Dim astrRET

If paramDay = "" Then
    adateCONSO = now
Else
    adateCONSO = cdate(paramDay)
End if

If paramPrice = "DAY" Then
    astrBuffer = paramConso & " " & astrFormatElect & ", " & round(cdbl((paramConso / 100) * adblPriceDay),2) & " " & astrFormatMoney
Else '--NIGHT
    astrBuffer = paramConso & " " & astrFormatElect & ", " & round((cdbl(paramConso / 100) * adblPriceNight),2) & " " & astrFormatMoney
End if

hs.SetDeviceString paramDevice, astrBuffer, True
hs.SetDeviceValue paramDevice, paramConso
hs.SetDeviceLastChange paramDevice, adateCONSO & " " & Time

If (paramDay = "") or ((Year(adateCONSO) <> Year(adateCURR)) or (Month(adateCONSO) <> Month(adateCURR))  or (Day(adateCONSO) <> Day(adateCURR))) Then
    astrRET = insertDeviceChange(paramDevice,paramDay,"ELECTRICITY.CONSUMPTION")
    If astrRET <> "" Then
        WriteLog G_FOLDER_NAME, aG_SCRIPT_EVT, G_TIV_SEV, astrRET, G_LOG_FILE
    End if  
End if
End sub

'--------------------------------------------------------------------
'-- OBJECTIVE   : GET THE CONSUMPTION FOR THE LAST N DAYS 
'-- PREREQUISITE: RFXPOWER and RFXCOM
'-- PARAMS IN   : paramDev   => Device which bring the consumptions
'--               paramNbDay => Last N Days
'--               paramDay   => Last Days (Date)
'-- PARAMS OUT  : 0 or SUM(all last consumption)
'-- CREATED BY DOMOTICS
'-- 29/12/2007
'--------------------------------------------------------------------
Function getConsoForNDays(paramDev,paramNbDay,paramDay)
Dim alngConso         : alngConso = Cdbl(0)
Dim adateCURR         : adateCURR = DateAdd("D", -1 * paramNbDay, paramDay)
Dim aG_SCRIPT_EVT     : aG_SCRIPT_EVT = "getConsoForNDays"
Dim astrQuery   
Dim aobjRS       

WriteLog G_FOLDER_NAME, aG_SCRIPT_EVT, G_TIV_INF, "Getting Conso for " & paramNbDay & " Days ( " & formatDay(adateCURR) &" , " & formatDay(paramDay) & " )", G_LOG_FILE
astrQuery = "SELECT SUM(value) FROM events WHERE device = '" & paramDev & "' AND date >= '" & formatDay(adateCURR) & "' AND date < '" & formatDay(paramDay) & "' ORDER BY id_event DESC" 
Set aobjRS = aobjConn.Execute(astrQuery)
SaveFileAppend astrFileSQL, astrQuery
If NOT(aobjRS.EOF) Then
    If Not(Isnull(aobjRS.Fields.Item(0))) Then
        alngConso = Cdbl(aobjRS.Fields.Item(0))
    Else
        alngConso = Cdbl(0)
    End if
End if
aobjRS.Close 
Set aobjRS        = Nothing
WriteLog G_FOLDER_NAME, aG_SCRIPT_EVT, G_TIV_INF, "Result Conso for " & paramNbDay & " Days = " & round(alngConso,2), G_LOG_FILE
getConsoForNDays  = Cdbl(alngConso)
End function

'--------------------------------------------------------------------
'-- OBJECTIVE   : Save detailed logs during full refresh 
'-- PREREQUISITE: RFXPOWER and RFXCOM
'-- PARAMS IN   : paramMode (Saving only when  true)
'--               paramFile (filename with full path)
'--               paramStr (Message to be saved)
'-- PARAMS OUT  : N/A
'-- CREATED BY DOMOTICS
'-- 29/12/2007
'--------------------------------------------------------------------
Sub saveDetailedLogs(paramFile, paramStr, paramMode)
If paramMode Then
  SaveFileAppend paramFile, paramStr
End if 
End sub

'--------------------------------------------------------------------
'-- OBJECTIVE   : Set And Save Cuts and Ano 
'--               No Save for the current Day 
'-- PREREQUISITE: RFXPOWER and RFXCOM
'-- PARAMS IN   : paramDevice => Device used to assign
'--               paramValue  => Consumption to be assigned
'--               paramFormat => String Format to be added to the value
'--               paramFile   => File to be written
'--               paramBuffer => Buffer to be written in the file
'--               paramDay    => Current Day
'-- PARAMS OUT  : N/A
'-- CREATED BY DOMOTICS
'-- 29/12/2007
'--------------------------------------------------------------------
Sub setCutsOrAnos(paramDevice, paramValue, paramFormat, paramFile, paramBuffer, paramDay)
Dim adateCURR     : adateCURR = now
Dim aG_SCRIPT_EVT : aG_SCRIPT_EVT = "setCutsOrAnos"
Dim adateSAVE
Dim astrSQL
Dim astrRET 

WriteLog G_FOLDER_NAME, aG_SCRIPT_EVT, G_TIV_INF, "Saving new calculated values ...", G_LOG_FILE
If paramDay = "" Then
    adateSAVE = now
Else
    adateSAVE = cdate(paramDay)
End if

hs.SetDeviceString paramDevice, paramValue & " " & paramFormat, True
hs.SetDeviceValue paramDevice, paramValue
hs.SetDeviceLastChange paramDevice, adateSAVE & " " & Time

If (paramDay = "") or ((Year(adateSAVE) <> Year(adateCURR)) or (Month(adateSAVE) <> Month(adateCURR))  or (Day(adateSAVE) <> Day(adateCURR))) Then
    astrRET = insertDeviceChange(paramDevice,paramDay,"ELECTRICITY.CONSUMPTION")
    If astrRET <> "" Then
        WriteLog G_FOLDER_NAME, aG_SCRIPT_EVT, G_TIV_SEV, astrRET, G_LOG_FILE
    End if
    SaveFileByType paramFile, paramBuffer, G_FILETYPE_ASCII
End if
End sub

'--------------------------------------------------------------------
'-- OBJECTIVE   : Get last value from db 
'-- PREREQUISITE: RFXPOWER and RFXCOM
'-- PARAMS IN   : paramDevice => Device used to assign
'--               paramDay    => Current Day
'-- PARAMS OUT  : astrLastValue (From Db)
'-- CREATED BY DOMOTICS
'-- 29/12/2007
'--------------------------------------------------------------------
Function getLastValueFromDb(paramDevice, paramDay, paramDefaultValue)
Dim astrLastValue : astrLastValue = ""
Dim aG_SCRIPT_EVT : aG_SCRIPT_EVT = "getLastValueFromDb"
Dim astrQuery 
Dim aobjRS

WriteLog G_FOLDER_NAME, aG_SCRIPT_EVT, G_TIV_INF, "Getting last value from db ...", G_LOG_FILE
astrQuery = "SELECT * FROM events WHERE device = '" & paramDevice & "' AND date like '" & formatDay(paramDay) & "%' ORDER BY id_event DESC" 
Set aobjRS = aobjConn.Execute(astrQuery)
SaveFileAppend astrFileSQL, astrQuery
If NOT(aobjRS.EOF) Then
    astrLastValue = aobjRS.Fields.Item(4)   
End if
aobjRS.Close 
Set aobjRS       = Nothing
If astrLastValue = "" Then
    WriteLog G_FOLDER_NAME, aG_SCRIPT_EVT, G_TIV_INF, paramDevice & " = " & paramDefaultValue & " (" & paramDay & ") ", G_LOG_FILE
    getLastValueFromDb = paramDefaultValue  
Else
    WriteLog G_FOLDER_NAME, aG_SCRIPT_EVT, G_TIV_INF, paramDevice & " = " & astrLastValue & " (" & paramDay & ") ", G_LOG_FILE
    getLastValueFromDb = astrLastValue
End if
End Function 
